import java.awt.Color;
import java.awt.Component;

import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListCellRenderer;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;


public class TableTest {
	
	public static void main(String[] args){
		JFrame frame = new JFrame("Table");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		TableModel model = new TableModel();
		JTable table = new JTable(model);
		
		TableColumn choice = table.getColumnModel().getColumn(1);
		
		JComboBox testBox = new JComboBox();
		testBox.addItem("Black");
		testBox.addItem("Green");
		testBox.addItem("Blue");
		testBox.addItem("Red");
		testBox.setRenderer(new ComboColorRenderer());
		choice.setCellEditor(new DefaultCellEditor(testBox));
		
		
		
        DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
        renderer.setToolTipText("Click for combo box");
        choice.setCellRenderer(renderer);
		
		
		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setOpaque(true);
		frame.add(scrollPane);
		frame.setSize(800, 100);
		frame.pack();
		frame.setVisible(true);
	}
	
}

class TableModel extends AbstractTableModel{
	private String[] columns = {"Text Field", "Combo Box", "Checkbox"};
	private Object[][] data = {
				{"Text", "", false},
				{"Text", "",  },
				{"Text", "", false}
	};
	
	public int getColumnCount() {return columns.length;}
	public int getRowCount() {return data.length;}
	public String getColumnName(int col){return columns[col];}
	public Object getValueAt(int row, int col){ return data[row][col]; }
	
	//All of our cells are editable
	public boolean isCellEditable(int row, int col){return true;}
	
	public void setValueAt(Object value, int row, int col){
		data[row][col] = value;
		fireTableCellUpdated(row, col);
		if (debug()){System.out.println("Value Set");}
		
	}
	
    public Class getColumnClass(int c) {return getValueAt(0, c).getClass();}

    public boolean debug(){
    	boolean DEBUG = true;
    	return DEBUG;
    }
	}

//Combo Box Renderer Class to display colors for node
class ComboColorRenderer extends JLabel implements ListCellRenderer{
	public Component getListCellRendererComponent(
			JList list,
			Object value,
			int index,
			boolean isSelected,
			boolean cellHasFocus){

		Color[] thisColor = {Color.black, Color.green, Color.blue, Color.red};
		
		this.setOpaque(true);
		this.setText("     ");
		setBackground(thisColor[index]);
		return this;
	}
}
